Index: codes/icosagcm/devel/src/output/set_bounds.f90
===================================================================
--- codes/icosagcm/devel/src/output/set_bounds.f90	(revision 880)
+++ codes/icosagcm/devel/src/output/set_bounds.f90	(revision 880)
@@ -0,0 +1,206 @@
+MODULE set_bounds_mod
+  USE geometry, ONLY : swap_geometry, lon_e, lat_e
+  USE dimensions, ONLY : swap_dimensions, u_pos
+  USE math_const, ONLY : Pi
+  USE domain_mod, ONLY : t_domain, t_cellset, domloc_glo_ind
+  USE spherical_geom_mod, ONLY : xyz2lonlat
+
+  IMPLICIT NONE
+  PRIVATE
+  SAVE
+
+  PUBLIC :: set_bounds
+
+CONTAINS
+
+  SUBROUTINE set_bounds_primal(d, cells, all, own)
+    TYPE(t_domain) :: d
+    TYPE(t_cellset) :: cells
+    LOGICAL :: all, own(:,:)         ! if all is .TRUE., include halo cells
+    REAL :: lon,lat
+    INTEGER :: i,j,k, n, halo_size
+
+    halo_size = MERGE(1,0,all)
+
+    ! count primal cells
+    n=0
+    DO j=d%jj_begin-halo_size, d%jj_end+halo_size
+       DO i=d%ii_begin-halo_size, d%ii_end+halo_size
+          IF (own(i,j) .OR. all ) n=n+1
+       ENDDO
+    ENDDO
+    cells%ncell = n
+    
+    ! now set bounds
+    ALLOCATE(cells%ij(n), cells%lon(n), cells%lat(n), cells%ind_glo(n))
+    ALLOCATE(cells%bnds_lon(0:5,n), cells%bnds_lat(0:5,n))
+
+    n=0
+    DO j=d%jj_begin-halo_size, d%jj_end+halo_size
+       DO i=d%ii_begin-halo_size, d%ii_end+halo_size
+          IF (own(i,j) .OR. all) THEN
+             n=n+1
+             CALL xyz2lonlat(d%xyz(:,i,j), lon, lat)
+             cells%lon(n)=lon*180./Pi
+             cells%lat(n)=lat*180./Pi
+             DO k=0,5
+                CALL xyz2lonlat(d%vertex(:,k,i,j), lon, lat)
+                cells%bnds_lon(k,n)=lon*180./Pi
+                cells%bnds_lat(k,n)=lat*180./Pi
+             END DO
+             cells%ij(n)=d%iim*(j-1)+i
+             cells%ind_glo(n) = d%assign_cell_glo(i,j)-1
+          END IF
+       END DO
+    END DO
+
+!    PRINT *, 'set_bounds_primal', all, halo_size, cells%ncell
+  END SUBROUTINE set_bounds_primal
+
+  SUBROUTINE set_bounds_dual(d, cells)
+    USE metric, ONLY : vup, vdown
+    TYPE(t_domain) :: d
+    TYPE(t_cellset) :: cells
+    REAL :: lonc, latc, lon(0:2), lat(0:2)
+    INTEGER :: i,j,k,n
+
+    ! count dual cells
+    n=0
+    DO j=d%jj_begin+1,d%jj_end
+       DO i=d%ii_begin,d%ii_end-1
+          n=n+2
+       ENDDO
+    ENDDO
+    cells%ncell = n
+
+    ! now set bounds
+    ALLOCATE(cells%ind_glo(n)) ! not set but must be allocated
+    ALLOCATE(cells%ij(n), cells%lon(n), cells%lat(n))
+    ALLOCATE(cells%bnds_lon(0:2,n), cells%bnds_lat(0:2,n))
+
+    n=0
+    DO j=d%jj_begin+1,d%jj_end
+       DO i=d%ii_begin,d%ii_end-1
+          n=n+1
+          CALL xyz2lonlat(d%vertex(:,vdown,i,j), lonc, latc)
+          CALL xyz2lonlat(d%xyz(:,i,j),     lon(0), lat(0))
+          CALL xyz2lonlat(d%xyz(:,i,j-1),   lon(1), lat(1))
+          CALL xyz2lonlat(d%xyz(:,i+1,j-1), lon(2), lat(2))
+          cells%lon(n)=lonc*180./Pi
+          cells%lat(n)=latc*180/Pi
+          DO k=0,2
+             cells%bnds_lat(k,n)=lat(k)*180./Pi
+             cells%bnds_lon(k,n)=lon(k)*180./Pi
+          END DO
+          cells%ij(n) = d%z_down + d%iim*(j-1)+i
+       ENDDO
+    ENDDO
+    
+    DO j=d%jj_begin,d%jj_end-1
+       DO i=d%ii_begin+1,d%ii_end
+          n=n+1
+          CALL xyz2lonlat(d%vertex(:,vup,i,j), lonc, latc)
+          CALL xyz2lonlat(d%xyz(:,i,j),     lon(0), lat(0))
+          CALL xyz2lonlat(d%xyz(:,i,j+1),   lon(1), lat(1))
+          CALL xyz2lonlat(d%xyz(:,i-1,j+1), lon(2), lat(2))
+          cells%lon(n)=lonc*180./Pi
+          cells%lat(n)=latc*180/Pi
+          DO k=0,2
+             cells%bnds_lat(k,n)=lat(k)*180./Pi
+             cells%bnds_lon(k,n)=lon(k)*180./Pi
+          END DO
+          cells%ij(n) = d%z_up + d%iim*(j-1)+i
+       ENDDO
+    ENDDO
+
+  END SUBROUTINE set_bounds_dual
+
+  SUBROUTINE set_bounds_edge(ind, d, cells)
+    USE metric, ONLY : cell_glo
+    INTEGER, INTENT(IN) :: ind
+    TYPE(t_domain) :: d
+    TYPE(t_cellset) :: cells
+    REAL :: lon(2), lat(2)
+    INTEGER :: i,j,ij,k,kk,n
+    
+    ! count edges
+    n=0
+    DO j=d%jj_begin,d%jj_end
+       DO i=d%ii_begin,d%ii_end
+          DO k=0,5
+             IF (d%edge_assign_domain(k,i,j)==domloc_glo_ind(ind) &
+                  .AND. d%edge_assign_i(k,i,j)==i &
+                  .AND. d%edge_assign_j(k,i,j)==j &
+                  .AND. d%edge_assign_pos(k,i,j)==k) n=n+1
+          END DO
+       END DO
+    END DO
+    cells%ncell = n
+
+    ! now set bounds
+    ALLOCATE(cells%ij(n), cells%lon(n), cells%lat(n), cells%ind_glo(n))
+    ALLOCATE(cells%sgn(n)) ! flip sign when reading/writing
+    ALLOCATE(cells%bnds_lon(2,n), cells%bnds_lat(2,n))
+
+    CALL swap_dimensions(ind)
+    CALL swap_geometry(ind)
+    
+    n=0
+    DO j=d%jj_begin,d%jj_end
+       DO i=d%ii_begin,d%ii_end
+          DO k=0,5
+             IF (d%edge_assign_domain(k,i,j)==domloc_glo_ind(ind) &
+                  .AND. d%edge_assign_i(k,i,j)==i &
+                  .AND. d%edge_assign_j(k,i,j)==j &
+                  .AND. d%edge_assign_pos(k,i,j)==k) THEN
+                n=n+1
+                ij=(j-1)*d%iim+i+u_pos(k+1)
+                kk = MOD(k+d%delta(i,j)+6,6)
+                cells%ij(n)     = ij
+                cells%sgn(n)    = d%edge_assign_sign(k,i,j)
+                cells%ind_glo(n)= cell_glo(d%assign_cell_glo(i,j))%edge(kk)-1
+                cells%lon(n)    = lon_e(ij)*180./Pi
+                cells%lat(n)    = lat_e(ij)*180./Pi
+               
+                kk = MOD(k-1+6,6)
+                CALL xyz2lonlat(d%vertex(:,kk,i,j), lon(1),lat(1))
+                CALL xyz2lonlat(d%vertex(:,k, i,j), lon(2),lat(2))
+                cells%bnds_lon(:,n)=lon(:)*180./Pi
+                cells%bnds_lat(:,n)=lat(:)*180/Pi
+             END IF
+          END DO
+       END DO
+    END DO
+
+  END SUBROUTINE set_bounds_edge
+
+  SUBROUTINE set_bounds(domain_type, glo)
+    TYPE(t_domain), POINTER :: domain_type(:), d
+    LOGICAL :: glo
+    INTEGER :: ind
+    !$OMP BARRIER    
+    !$OMP MASTER
+    ! IF glo is .TRUE. we are dealing with the global mesh, otherwise with the local mesh
+    ! write_field uses the global mesh and may want halo cells
+    ! output_field (XIOS) uses the local mesh and uses only own cells
+    ! output_field uses edges while write_field uses only primal and dual cells
+    DO ind=1, SIZE(domain_type)
+       d=>domain_type(ind)
+       IF(glo) THEN ! global mesh / write_field
+          ! primal cell i,j is owned if d%assign_domain(i,j)==ind
+          CALL set_bounds_primal(d, d%primal_own, .FALSE., d%assign_domain==ind)
+          CALL set_bounds_primal(d, d%primal_all, .TRUE., d%assign_domain==ind)
+          CALL set_bounds_dual(d, d%dual_own)
+          CALL set_bounds_dual(d, d%dual_all)
+       ELSE  ! local mesh / XIOS
+          ! primal cell i,j is owned if d%own(i,j)==.TRUE.
+          CALL set_bounds_primal(d, d%primal_own, .FALSE., d%own)
+          CALL set_bounds_dual(d, d%dual_own)
+          CALL set_bounds_edge(ind, d, d%edge_own)
+       END IF
+    END DO
+    !$OMP END MASTER
+    !$OMP BARRIER
+  END SUBROUTINE set_bounds
+  
+END MODULE set_bounds_mod
Index: codes/icosagcm/devel/src/output/write_field.f90
===================================================================
--- codes/icosagcm/devel/src/output/write_field.f90	(revision 879)
+++ codes/icosagcm/devel/src/output/write_field.f90	(revision 880)
@@ -1,21 +1,7 @@
 module write_field_mod
   USE genmod
+  USE write_field_vars_mod
   IMPLICIT NONE
   PRIVATE  
-  INTEGER,SAVE :: ncprec
-  
-  TYPE ncvar
-    INTEGER :: size
-    INTEGER,POINTER :: nc_id(:)
-    INTEGER :: displ
-  END TYPE ncvar
-
-  INTEGER, PARAMETER :: MaxWriteField = 1000
-  INTEGER, DIMENSION(MaxWriteField),SAVE :: FieldId
-  TYPE(ncvar), dimension(MaxWriteField),SAVE :: FieldVarId
-  INTEGER, DIMENSION(MaxWriteField),SAVE :: FieldIndex
-  CHARACTER(len=255), DIMENSION(MaxWriteField) ::  FieldName 
-   
-  INTEGER,SAVE :: NbField = 0
   
   PUBLIC init_writeField, writefield, close_files
@@ -43,25 +29,5 @@
     END SUBROUTINE init_writeField
     
-    function GetFieldIndex(name)
-    implicit none
-      integer          :: GetFieldindex
-      character(len=*) :: name
-    
-      character(len=255) :: TrueName
-      integer            :: i
-       
-      
-      TrueName=TRIM(ADJUSTL(name))
-    
-      GetFieldIndex=-1
-      do i=1,NbField
-        if (TrueName==FieldName(i)) then
-          GetFieldIndex=i
-          exit
-        endif
-      enddo
-    end function GetFieldIndex
-    
-    SUBROUTINE Writefield(name_in,field,nind,once)
+   SUBROUTINE Writefield(name_in,field,nind,once)
     USE domain_mod
     USE field_mod
@@ -71,5 +37,4 @@
     USE netcdf_mod
     USE grid_param
-    IMPLICIT NONE  
      CHARACTER(LEN=*),INTENT(IN) :: name_in
       TYPE(t_field),POINTER :: field(:)
@@ -81,5 +46,4 @@
       
       IF (no_io) RETURN
-      IF (grid_type==grid_unst) RETURN
 
 !$OMP BARRIER
@@ -91,14 +55,18 @@
       END IF
 
-      IF (field(1)%ndim==2) THEN
-        CALL allocate_field_glo(field_glo,field(1)%field_type,field(1)%data_type)
-      ELSE IF (field(1)%ndim==3) THEN
-        CALL allocate_field_glo(field_glo,field(1)%field_type,field(1)%data_type,field(1)%dim3) 
-      ELSE IF (field(1)%ndim==4) THEN
-        CALL allocate_field_glo(field_glo,field(1)%field_type,field(1)%data_type,field(1)%dim3,field(1)%dim4)
-      ENDIF
-      
-      CALL gather_field(field,field_glo)
-      
+      IF (grid_type==grid_ico) THEN
+         IF (field(1)%ndim==2) THEN
+            CALL allocate_field_glo(field_glo,field(1)%field_type,field(1)%data_type)
+         ELSE IF (field(1)%ndim==3) THEN
+            CALL allocate_field_glo(field_glo,field(1)%field_type,field(1)%data_type,field(1)%dim3) 
+         ELSE IF (field(1)%ndim==4) THEN
+            CALL allocate_field_glo(field_glo,field(1)%field_type,field(1)%data_type,field(1)%dim3,field(1)%dim4)
+         ENDIF
+         
+         CALL gather_field(field,field_glo)
+      ELSE
+         field_glo => field ! FIXME unstructured + MPI
+      END IF
+
       IF (mpi_rank==0) THEN
         IF (PRESENT(nind)) THEN
@@ -109,5 +77,5 @@
       ENDIF
       
-      CALL deallocate_field_glo(field_glo)
+      IF(grid_type == grid_ico) CALL deallocate_field_glo(field_glo)
 !$OMP END MASTER
 !$OMP BARRIER
@@ -115,255 +83,27 @@
    END SUBROUTINE writefield
    
-!   SUBROUTINE Writefield(name_in,field,nind)
-!   USE netcdf
-!   USE domain_mod
-!   use field_mod
-!   USE dimensions
-!   USE geometry
-!   IMPLICIT NONE
-!     CHARACTER(LEN=*),INTENT(IN) :: name_in
-!     TYPE(t_field),POINTER :: field(:)
-!     INTEGER,OPTIONAL,INTENT(IN) :: nind
-!     REAL(r8),ALLOCATABLE :: field_val2d(:)
-!     REAL(r8),ALLOCATABLE :: field_val3d(:,:)
-!     REAL(r8),ALLOCATABLE :: field_val4d(:,:,:)
-!     TYPE(t_domain),POINTER :: d
-!     INTEGER :: Index
-!     INTEGER :: ind,i,j,k,n,ncell,q
-!     INTEGER :: iie,jje,iin,jjn
-!     INTEGER :: status
-!     CHARACTER(len=255) :: name
-!     CHARACTER(len=255) :: str_ind
-!     INTEGER :: ind_b,ind_e
-!     INTEGER :: halo_size
-!     LOGICAL :: single
-!     
-!     
-!     name=TRIM(ADJUSTL(name_in))
-
-!     IF (PRESENT(nind)) THEN
-!       name=TRIM(name)//"_"//TRIM(int2str(nind))
-!       PRINT *,"NAME",nind,int2str(nind),name
-!       ind_b=nind
-!       ind_e=nind
-!       halo_size=1
-!       single=.TRUE.
-!     ELSE
-!       ind_b=1
-!       ind_e=ndomain
-!       halo_size=0
-!       single=.FALSE.
-!     ENDIF      
-
-!     Index=GetFieldIndex(name)
-!     if (Index==-1) then
-!       call create_header(name,field,nind)
-!	Index=GetFieldIndex(name)
-!     else
-!       FieldIndex(Index)=FieldIndex(Index)+1.
-!     endif
-!     
-!     IF (Field(ind_b)%field_type==field_T) THEN
-!       ncell=1
-!       DO ind=ind_b,ind_e
-!         d=>domain(ind)
-!         IF (Field(ind)%field_type/=field_T) THEN
-!           PRINT *,"Writefield, grille non geree"
-!           RETURN
-!         ENDIF
-
-!       n=0
-!       DO j=d%jj_begin-halo_size,d%jj_end+halo_size
-!         DO i=d%ii_begin-halo_size,d%ii_end+halo_size
-!           IF (d%own(i,j) .OR. single) n=n+1
-!         ENDDO
-!       ENDDO
-
-!       IF (field(ind)%ndim==2) THEN
-!         ALLOCATE(Field_val2d(n))
-!         n=0
-!         DO j=d%jj_begin-halo_size,d%jj_end+halo_size
-!           DO i=d%ii_begin-halo_size,d%ii_end+halo_size
-!             k=d%iim*(j-1)+i
-!             IF (d%own(i,j) .OR. single) THEN
-!               n=n+1
-!               Field_val2d(n)=field(ind)%rval2d(k)
-!             ENDIF
-!           ENDDO
-!         ENDDO
-!         status=NF90_PUT_VAR(FieldId(Index),FieldVarId(index)%nc_id(1),Field_val2d,  &
-!                             start=(/ ncell,FieldIndex(Index) /),count=(/n,1 /))
-!         DEALLOCATE(field_val2d)
-!       ELSE IF (field(ind)%ndim==3) THEN
-!         ALLOCATE(Field_val3d(n,size(field(ind)%rval3d,2)))
-!         n=0
-!         DO j=d%jj_begin-halo_size,d%jj_end+halo_size
-!           DO i=d%ii_begin-halo_size,d%ii_end+halo_size
-!             k=d%iim*(j-1)+i
-!             IF (d%own(i,j) .OR. single) THEN
-!               n=n+1
-!               Field_val3d(n,:)=field(ind)%rval3d(k,:)
-!             ENDIF
-!           ENDDO
-!         ENDDO
-!          status=NF90_PUT_VAR(FieldId(Index),FieldVarId(index)%nc_id(1),Field_val3d,start=(/ ncell,1,FieldIndex(Index) /),   &
-!                              count=(/n,size(field(1)%rval3d,2),1 /))
-!         DEALLOCATE(field_val3d)
-!       ELSE IF (field(1)%ndim==4) THEN
-
-!         DO q=1,FieldVarId(index)%size
-!         
-!           ALLOCATE(Field_val3d(n,size(field(ind)%rval4d,2)))
-!           n=0
-!           DO j=d%jj_begin-halo_size,d%jj_end+halo_size
-!             DO i=d%ii_begin-halo_size,d%ii_end+halo_size
-!               k=d%iim*(j-1)+i
-!               IF (d%own(i,j) .OR. single) THEN
-!                 n=n+1
-!                 Field_val3d(n,:)=field(ind)%rval4d(k,:,q)
-!               ENDIF
-!             ENDDO
-!           ENDDO
-!           status=NF90_PUT_VAR(FieldId(Index),FieldVarId(index)%nc_id(q),Field_val3d,start=(/ ncell,1,FieldIndex(Index) /),   &
-!                              count=(/n,size(field(1)%rval4d,2),1 /))
-!           DEALLOCATE(field_val3d)
-!         ENDDO         
-!       ENDIF
-!       
-!        PRINT *,NF90_STRERROR(status)
-!       ncell=ncell+n
-
-!    ENDDO
-!    
-!    ELSE IF (Field(ind_b)%field_type==field_Z) THEN
-!       ncell=1
-!       n=0
-!       DO ind=ind_b,ind_e
-!         d=>domain(ind)
-!         CALL swap_geometry(ind)
-!         CALL swap_dimensions(ind)
-! 
-!         n=0
-!         DO j=jj_begin+1,jj_end
-!           DO i=ii_begin,ii_end-1
-!             n=n+1
-!           ENDDO
-!         ENDDO
-
-!         DO j=jj_begin,jj_end-1
-!           DO i=ii_begin+1,ii_end
-!             n=n+1
-!           ENDDO
-!         ENDDO
-
-!       IF (field(ind)%ndim==2) THEN
-!         ALLOCATE(Field_val2d(n))
-
-!         n=0
-!         DO j=jj_begin+1,jj_end
-!           DO i=ii_begin,ii_end-1
-!             n=n+1
-!             k=iim*(j-1)+i
-!             Field_val2d(n)=field(ind)%rval2d(k+z_down)
-!           ENDDO
-!         ENDDO
-
-!         DO j=jj_begin,jj_end-1
-!           DO i=ii_begin+1,ii_end
-!             n=n+1
-!             k=iim*(j-1)+i
-!             Field_val2d(n)=field(ind)%rval2d(k+z_up)
-!           ENDDO
-!         ENDDO
-
-!         status=NF90_PUT_VAR(FieldId(Index),FieldVarId(index)%nc_id(1),                       &
-!                             Field_val2d,start=(/ ncell,FieldIndex(Index) /),count=(/n,1 /))
-!         DEALLOCATE(field_val2d)
-
-!       ELSE IF (field(ind)%ndim==3) THEN
-!         ALLOCATE(Field_val3d(n,size(field(ind)%rval3d,2)))
-!         n=0
-!         DO j=jj_begin+1,jj_end
-!           DO i=ii_begin,ii_end-1
-!             n=n+1
-!             k=iim*(j-1)+i
-!             Field_val3d(n,:)=field(ind)%rval3d(k+z_down,:)
-!           ENDDO
-!         ENDDO
-
-!         DO j=jj_begin,jj_end-1
-!           DO i=ii_begin+1,ii_end
-!             n=n+1
-!             k=iim*(j-1)+i
-!             Field_val3d(n,:)=field(ind)%rval3d(k+z_up,:)
-!           ENDDO
-!         ENDDO
-!          status=NF90_PUT_VAR(FieldId(Index),FieldVarId(index)%nc_id(1),Field_val3d,start=(/ ncell,1,FieldIndex(Index) /),   &
-!                              count=(/n,size(field(1)%rval3d,2),1 /))
-!         DEALLOCATE(field_val3d)
-!       ELSE IF (field(1)%ndim==4) THEN
-
-!         DO q=1,FieldVarId(index)%size
-!           ALLOCATE(Field_val3d(n,size(field(ind)%rval4d,2)))
-!           n=0
-!           DO j=jj_begin+1,jj_end
-!             DO i=ii_begin,ii_end-1
-!               n=n+1
-!               k=iim*(j-1)+i
-!               Field_val3d(n,:)=field(ind)%rval4d(k+z_down,:,q)
-!             ENDDO
-!           ENDDO
-
-!           DO j=jj_begin,jj_end-1
-!             DO i=ii_begin+1,ii_end
-!               n=n+1
-!               k=iim*(j-1)+i
-!               Field_val3d(n,:)=field(ind)%rval4d(k+z_up,:,q)
-!             ENDDO
-!           ENDDO
-
-!           status=NF90_PUT_VAR(FieldId(Index),FieldVarId(index)%nc_id(q),Field_val3d,start=(/ ncell,1,1,FieldIndex(Index) /),   &
-!                               count=(/n,size(field(1)%rval4d,2),1 /))
-!           DEALLOCATE(field_val3d)
-!         ENDDO
-!       ENDIF
-!       
-!        PRINT *,NF90_STRERROR(status)
-!       ncell=ncell+n
-
-!    ENDDO
-!    
-!    ENDIF
-!    status=NF90_SYNC(FieldId(Index))
-!     
-!   END SUBROUTINE Writefield
-
-
-    SUBROUTINE Writefield_gen(name_in, field, domain_type, ind_b_in, ind_e_in,once )
-    USE netcdf_mod
-    USE domain_mod
-    USE field_mod
-    IMPLICIT NONE
-      CHARACTER(LEN=*),INTENT(IN) :: name_in
-      TYPE(t_field), POINTER :: field(:)
-      TYPE(t_domain),INTENT(IN),TARGET :: domain_type(:)
-      INTEGER,OPTIONAL,INTENT(IN) :: ind_b_in
-      INTEGER,OPTIONAL,INTENT(IN) :: ind_e_in
-      REAL(r8),ALLOCATABLE :: field_val2d(:)
-      REAL(r8),ALLOCATABLE :: field_val3d(:,:)
-      REAL(r8),ALLOCATABLE :: field_val4d(:,:,:)
-      LOGICAL, INTENT(IN) :: once
-      TYPE(t_domain),POINTER :: d
-      INTEGER :: Index
-      INTEGER :: ind,i,j,k,n,ncell,q
-      INTEGER :: iie,jje,iin,jjn
-      INTEGER :: status
-      CHARACTER(len=255) :: name
-      CHARACTER(len=255) :: str_ind
-      INTEGER :: ind_b,ind_e
-      INTEGER :: halo_size
-      LOGICAL :: single
-      
-      name=TRIM(ADJUSTL(name_in))
+   SUBROUTINE Writefield_gen(name_in, field, domain_type, ind_b_in, ind_e_in,once )
+     USE netcdf_mod
+     USE domain_mod
+     USE field_mod
+     CHARACTER(LEN=*),INTENT(IN) :: name_in
+     TYPE(t_field), POINTER :: field(:)
+     TYPE(t_domain),INTENT(IN),TARGET :: domain_type(:)
+     INTEGER,OPTIONAL,INTENT(IN) :: ind_b_in
+     INTEGER,OPTIONAL,INTENT(IN) :: ind_e_in
+     LOGICAL, INTENT(IN) :: once
+     ! local variables
+     TYPE(t_cellset), POINTER :: cells(:)
+     TYPE(t_domain),POINTER :: d
+     LOGICAL :: single
+     INTEGER :: ind_b, ind_e, ind
+     CHARACTER(len=255) :: name
+     INTEGER :: index, ncell, nvert, n
+     ! for embedded routines
+     REAL(r8),ALLOCATABLE :: field_val2d(:)
+     REAL(r8),ALLOCATABLE :: field_val3d(:,:)
+     INTEGER :: status, n_begin, ij, q, dim3
+
+     name=TRIM(ADJUSTL(name_in))
 
       IF (PRESENT(ind_b_in) .AND. .NOT. PRESENT(ind_e_in)) THEN
@@ -371,5 +111,4 @@
         ind_b=ind_b_in
         ind_e=ind_b_in
-        halo_size=1
         single=.TRUE.
       ELSE IF (.NOT. PRESENT(ind_b_in) .AND. PRESENT(ind_e_in)) THEN
